/*
 * uninformed  -- IP scanning API using IPBlocks
 *
 * skape
 * 06/13/2002
 */
#ifndef _SCANAPI_H
#define _SCANAPI_H

#include <pthread.h>

#include "ipblocks.h"

typedef struct _scanapi_ctx {

	IPBLOCK *ipblock;

	char    *target;
	void    *userData;
	short   threads;
	short   ipPerThread;
	short   verbose;

	char    (*callback)(void *userData, unsigned long *ips, unsigned int ipCount);

	short           currentThreads;
	pthread_mutex_t currentThreadsMutex;

} SCANAPI_CTX;

void scanapiDefaults(SCANAPI_CTX *ctx);
short scanapiInitialize(SCANAPI_CTX *ctx, void *userData, char (*callback)(void *userData, unsigned long *ips, unsigned int ipCount));
short scanapiStart(SCANAPI_CTX *ctx);
short scanapiDeinitialize(SCANAPI_CTX *ctx);

void scanapiThreadCountIncrement(SCANAPI_CTX *ctx);
void scanapiThreadCountDecrement(SCANAPI_CTX *ctx);
short scanapiThreadCountGet(SCANAPI_CTX *ctx);

#endif
